stages:
  - build
  - test
  - deploy
  - activate  
  - revert

variables:
  remote_deploy_path: '/www'
  remote_html_path: "/var/www"
  env: prod
  deploy_subfolder: test-app-3/html
  remote_con_string: "root@45.141.101.185"
  app_name: "test-app-3"

before_script:
  - apt-get update -y
  - 'which ssh-agent || ( apt-get install openssh-client -y )'
  - apt-get install rsync -y
  - eval $(ssh-agent -s)
  - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -


deploy_staging:
  extends: deploy_prod
  variables:
    deploy_subfolder: staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - master
    - /feature-.*/

deploy_prod:
  stage: deploy
  script:
    - ssh -o StrictHostKeyChecking=no $remote_con_string "mkdir -p $remote_deploy_path/${app_name}/${env}_$CI_COMMIT_SHA"
    - rsync -az -e 'ssh -o StrictHostKeyChecking=no' ./html/* $remote_con_string:$remote_deploy_path/${app_name}/${env}_$CI_COMMIT_SHA
    - ssh -o StrictHostKeyChecking=no $remote_con_string "cp -Pv $remote_html_path/$deploy_subfolder $remote_deploy_path/${app_name}/${env}_$CI_COMMIT_SHA/prev-version || true"
  only:
    - master

activate_staging:
  extends: activate_prod
  variables:
    deploy_subfolder: test-app-3/staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - master
    - /feature-.*/

activate_prod:
  stage: activate
  script:
    - ssh -o StrictHostKeyChecking=no $remote_con_string "ln -fsnv $remote_deploy_path/${app_name}/${env}_$CI_COMMIT_SHA $remote_html_path/$deploy_subfolder"
  when: manual
  only:
    - master

revert_prod:
  stage: revert
  when: manual
  script:
    - ssh -o StrictHostKeyChecking=no $remote_con_string "cp -Pv --remove-destination $remote_deploy_path/${app_name}/${env}_$CI_COMMIT_SHA/prev-version $remote_deploy_path/$deploy_subfolder"
